//******************************************************************************
//GoldMap
//by BlueSonic (aka Jigglypuff)
//******************************************************************************
unit Main;

interface

uses
 Windows, SysUtils, Classes, Graphics, Forms, Spin, IniFiles, Menus, StdCtrls,
 Dialogs, Controls, ExtCtrls, ComCtrls, ImgList, XPMan, pngimage, Tweaks;

type

  EventInfo = record
    Number,TypeID: Byte;
    end;

  TPokemon = packed record
    Level:  Byte;
    Number: Byte;
    end;

  TWildPokemonBlock = packed record
    MapBank: Byte;
    MapNum:  Byte;
    MorningFreq: Byte;
    DayFreq:     Byte;
    NightFreq:   Byte;
    Morning: array [0..6] of TPokemon;
    Day:     array [0..6] of TPokemon;
    Night:   array [0..6] of TPokemon;
    end;

  TMainForm = class(TForm)
    OpenRomDialog: TOpenDialog;
    StatusBar1: TStatusBar;
    SaveRomDialog: TSaveDialog;
    OpenMapDialog: TOpenDialog;
    SaveMapDialog: TSaveDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    LoadRom1: TMenuItem;
    SaveRom1: TMenuItem;
    SaveRomAs1: TMenuItem;
    LoadMap1: TMenuItem;
    SaveMap1: TMenuItem;
    Exit1: TMenuItem;
    Settings1: TMenuItem;
    Grid1: TMenuItem;
    Tools: TMenuItem;
    BlockEditor1: TMenuItem;
    SaveMapPic1: TMenuItem;
    SaveTilesetPic1: TMenuItem;
    ReBuildEvents1: TMenuItem;
    TryMap1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    XPManifest1: TXPManifest;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    NoWildPokemonLabel: TLabel;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label3: TLabel;
    MorningLevel: TSpinEdit;
    MorningBox: TListBox;
    MorningCombo: TComboBox;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    DayLevel: TSpinEdit;
    DayBox: TListBox;
    DayCombo: TComboBox;
    GroupBox3: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    NightLevel: TSpinEdit;
    NightBox: TListBox;
    NightCombo: TComboBox;
    GroupBox4: TGroupBox;
    Label2: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    MaxPoke: TSpinEdit;
    RandomizeButton: TButton;
    MaxLev: TSpinEdit;
    MinPoke: TSpinEdit;
    MinLev: TSpinEdit;
    EventScrollBox: TScrollBox;
    MapScrollBox: TScrollBox;
    NoEventsLabel: TLabel;
    N1: TMenuItem;
    N2: TMenuItem;
    WarpImage: TImage;
    SignpostImage: TImage;
    PeopleImage: TImage;
    GameTweaks1: TMenuItem;
    N3: TMenuItem;
    MapBox: TPaintBox;
    EventBox: TPaintBox;
    MapTree: TTreeView;
    Splitter1: TSplitter;
    TriggerImage: TImage;
    N4: TMenuItem;
    Palette1: TMenuItem;
    Morning1: TMenuItem;
    Day1: TMenuItem;
    Night1: TMenuItem;
    Darkness1: TMenuItem;
    Indoor1: TMenuItem;
    ImageList1: TImageList;
    BlockPaletteScrollBox: TScrollBox;
    BlockPalette: TPaintBox;
    MapProperties1: TMenuItem;
    N5: TMenuItem;
    SortbyArea1: TMenuItem;
    SortbyBank1: TMenuItem;
    MorningTrack: TTrackBar;
    Label1: TLabel;
    Label12: TLabel;
    DayTrack: TTrackBar;
    Label13: TLabel;
    Label14: TLabel;
    NightTrack: TTrackBar;
    Label15: TLabel;
    Label16: TLabel;
    ReconstructMap1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure BlockPaletteMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure MapBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure BlockPaletteMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure MapBoxMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure DayLevelChange(Sender: TObject);
    procedure NightLevelChange(Sender: TObject);
    procedure MorningLevelChange(Sender: TObject);
    procedure MorningNumberChange(Sender: TObject);
    procedure DayNumberChange(Sender: TObject);
    procedure NightNumberChange(Sender: TObject);
    procedure Grid1Click(Sender: TObject);
    procedure BlockEditor1Click(Sender: TObject);
    procedure MorningBoxClick(Sender: TObject);
    procedure DayBoxClick(Sender: TObject);
    procedure NightBoxClick(Sender: TObject);
    procedure MapBoxMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure EventBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure EventBoxMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    function GetEventData(X,Y: Integer): EventInfo;
    procedure EventBoxMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SaveMapPicture1Click(Sender: TObject);
    procedure SaveTilesetPicture1Click(Sender: TObject);
    procedure DisplayHint(Sender: TObject);
    procedure BuildEvents1Click(Sender: TObject);
    procedure RandomizeButtonClick(Sender: TObject);
    procedure LoadMap1Click(Sender: TObject);
    procedure SaveMap1Click(Sender: TObject);
    procedure TryMap1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure MorningComboChange(Sender: TObject);
    procedure DayComboChange(Sender: TObject);
    procedure NightComboChange(Sender: TObject);
    procedure GameTweaks1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);

    //saves currently open map, event and pokemon data to rom (in memory) and writes to file
    procedure SaveRom(FileName: string);

    //loads specified map, tileset for map, map's events and pokemon
    procedure LoadMap(MapBank,MapNum: Byte);
    //loads specified tileset
    procedure LoadTileset(TilesetNumber: Byte);
    //loads wild pokemon data for specified map
    procedure LoadPokemon(MapBank,MapNum: Byte);

    //draws tileset blocks from MapData into Canvas
    procedure DrawMap(Canvas: TCanvas);
    //draws the tileset blocks on Canvas
    procedure DrawBlocks(Canvas: TCanvas);
    //refreshes the wild pokemon data controls in Wild Pokemon tab
    procedure UpdatePokemon;

    //saves currently loaded map, map's events and pokemon
    procedure SaveMap;
    //saves loaded wild pokemon data
    procedure SavePokemon;
    procedure MapBoxPaint(Sender: TObject);
    procedure BlockPalettePaint(Sender: TObject);
    procedure EventBoxPaint(Sender: TObject);
    procedure MapTreeChange(Sender: TObject; Node: TTreeNode);
    procedure BorderComboDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure MapProperties1Click(Sender: TObject);
    procedure MapTreeDblClick(Sender: TObject);
    procedure EventBoxDblClick(Sender: TObject);
    procedure SortbyBank1Click(Sender: TObject);
    procedure ViewPaletteClick(Sender: TObject);
    procedure AttackTrackChange(Sender: TObject);
    procedure ReconstructMap1Click(Sender: TObject);
   end;

var
  MainForm: TMainForm;
  LoadedTileset: Byte = 0;
  LoadedMap: string = '';
  LoadedMapBank: Byte;
  LoadedMapNum: Byte;
  MapX,MapY,SelBlock,SelPic,MapStart,TilesetStart,
  PokemonStart,Blocks: Integer;
  Rom: TMemoryStream = nil;
  MapData: array of Byte;
  BlockPics: array [0..255] of TBitmap;
  HideShowIni: TIniFile;
  Painting,DraggingEvent: boolean;
  SelectedEvent: EventInfo;
  CursorEvent: EventInfo;
  Tiles: TBitmap;
  MapModified: boolean;
  RomModified: boolean;
  DragOldX,DragOldY: Integer;
  WildPkmn: TWildPokemonBlock;

implementation

uses
BlockEditor, Events, People, warp, Signpost, EventBuilder, TryMap,
About, Types, Map, Tileset, MapProperties, ReconstructMap;

{$R *.DFM}

procedure TMainForm.DisplayHint(Sender: TObject);
begin
StatusBar1.Panels[1].Text := Application.Hint;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
ControlStyle := ControlStyle + [csOpaque];
MapScrollBox.ControlStyle := MapScrollBox.ControlStyle + [csOpaque];
MapBox.ControlStyle := MapBox.ControlStyle + [csOpaque];
//Create and load inis
HideShowIni := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'HideShow.ini');
Tiles := TBitmap.Create;
Tiles.Width := 16*16;
Tiles.Height := 16*6;
Tiles.PixelFormat := pf24bit;
Application.OnHint := DisplayHint;
//important for grid
MapBox.Canvas.Brush.Style := bsClear;
EventBox.Canvas.Brush.Style := bsClear;
BlockPalette.Canvas.Brush.Style := bsClear;
end;

procedure TMainForm.Load1Click(Sender: TObject);
begin
if OpenRomDialog.Execute then
 begin
 //Load rom
 if Rom = nil then
 Rom := TMemoryStream.Create;
 Rom.LoadFromFile(OpenRomDialog.FileName);
 StatusBar1.Panels[0].Text := 'Select map.';
 GameTweaks1.Enabled := True;
 TryMap1.Enabled     := True;
 MapModified := False;
 RomModified := False;
 BlockEditor1.Enabled    := False;
 MapProperties1.Enabled  := False;
 ReBuildEvents1.Enabled  := False;
 ReconstructMap1.Enabled := False;
 SaveRom1.Enabled   := True;
 SaveRomAs1.Enabled := True;
 ReadAreaNames;
 ScanMapHeaders;
 end;
end;

procedure TMainForm.BlockPaletteMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
//select block to be "painted" in map editor
SelBlock := (Y div 64);
end;

procedure TMainForm.MapBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
//Get block number where cursor is
SelPic := Y div 64 * MapX + X div 64;
//don't do anything with wrong coordinates
if (X < 0) or (Y < 0) or (SelPic >= MapX*MapY) then Exit;
//Show info in Status bar
StatusBar1.Panels[0].Text := 'X: ' + IntToStr(X div 64) + ' Y: ' + IntToStr(Y div 64) + ' Block: $' + IntToHex(MapData[SelPic],2) + ' Offset: $' + IntToHex(MapStart + SelPic,2);
//If mouse left button is pressed block is changed
if Painting then
 begin
 MapData[SelPic] := SelBlock;
 MapBox.Canvas.Draw(X div 64 * 64,Y div 64 * 64,BlockPics[SelBlock]);
 //if grid is selected, add it
 if Grid1.Checked then
 MapBox.Canvas.Rectangle(X div 64 *64,Y div 64 * 64,X div 64 * 64+64,Y div 64 *64+64);
 end;
end;

procedure TMainForm.BlockPaletteMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
//show block number and address in status bar
StatusBar1.Panels[0].Text := 'Block: $' + IntToHex(Y div 64,2) + ' Offset: $' + IntToHex(TilesetStart + ((Y div 64) * 16),0);
end;

procedure TMainForm.MapBoxMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
//change block if mouse button is left
if Button = mbLeft then
 begin
 MapModified := True;
 MapData[SelPic] := SelBlock;
 MapBox.Canvas.Draw(X div 64 * 64,Y div 64 * 64,BlockPics[SelBlock]);
 //if gid is sellected, add it
 if Grid1.Checked then
 MapBox.Canvas.Rectangle(X div 64 *64,Y div 64 * 64,X div 64 * 64+64,Y div 64 *64+64);
 //enable painting for OnMouseMove
 Painting := True;
 end
else
 begin
 //other buttons will select the block at cursor
 if (MapData[SelPic] <= Blocks) then
  begin
  BlockPaletteScrollBox.VertScrollBar.Position := 64 * MapData[SelPic];
  SelBlock := MapData[SelPic];
  end;
 end;
end;

procedure TMainForm.Save1Click(Sender: TObject);
begin
SaveRom(OpenRomDialog.FileName);
end;

procedure TMainForm.SaveAs1Click(Sender: TObject);
begin
if SaveRomDialog.Execute then
 begin
 SaveRom(SaveRomDialog.FileName);
 OpenRomDialog.FileName := SaveRomDialog.FileName;
 end;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
Close;
end;

procedure TMainForm.DayLevelChange(Sender: TObject);
begin
//change selected pokemon's level
WildPkmn.Day[DayBox.Itemindex].Level := DayLevel.Value;
UpdatePokemon;
end;

procedure TMainForm.NightLevelChange(Sender: TObject);
begin
//change selected pokemon's level
WildPkmn.Night[NightBox.ItemIndex].Level := NightLevel.Value;
UpdatePokemon;
end;

procedure TMainForm.MorningLevelChange(Sender: TObject);
begin
//change selected pokemon's level
WildPkmn.Morning[MorningBox.ItemIndex].Level := MorningLevel.Value;
UpdatePokemon;
end;

procedure TMainForm.MorningNumberChange(Sender: TObject);
begin
//change selected pokemon's number
WildPkmn.Morning[MorningBox.Itemindex].Number := MorningCombo.ItemIndex + 1;
UpdatePokemon;
MapModified := True;
end;

procedure TMainForm.DayNumberChange(Sender: TObject);
begin
//change selected pokemon's number
WildPkmn.Day[DayBox.Itemindex].Number := DayCombo.ItemIndex + 1;
UpdatePokemon;
MapModified := True;
end;

procedure TMainForm.NightNumberChange(Sender: TObject);
begin
//change selected pokemon's number
WildPkmn.Night[NightBox.Itemindex].Number := NightCombo.ItemIndex + 1;
UpdatePokemon;
MapModified := True;
end;

procedure TMainForm.Grid1Click(Sender: TObject);
begin
//if grid is checked then it will be hidden
if Grid1.Checked then
Grid1.Checked := False
else
//if grid is unchecked then it will be shown
Grid1.Checked := True;
//PokemonIni.WriteBool('Settings','Grid',Grid1.Checked);
//show the grid if needed
if MapStart > 0 then
 begin
 DrawMap(MainForm.MapBox.Canvas);
 DrawEvents(MainForm.EventBox.Canvas);
 DrawBlocks(BlockPalette.Canvas);
 end;
end;

procedure TMainForm.BlockEditor1Click(Sender: TObject);
begin
with TBlockEditorForm.Create(nil) do
 begin
 ShowModal;
 Free;
 end;
end;

procedure TMainForm.MorningBoxClick(Sender: TObject);
begin
//allow editing pokemon's level and number
MorningCombo.ItemIndex := WildPkmn.Morning[MorningBox.ItemIndex].Number -1;
MorningLevel.Value := WildPkmn.Morning[MorningBox.ItemIndex].Level;
end;

procedure TMainForm.DayBoxClick(Sender: TObject);
begin
//allow editing pokemon's level and number
DayCombo.ItemIndex := WildPkmn.Day[DayBox.ItemIndex].Number -1;
DayLevel.Value := WildPkmn.Day[DayBox.ItemIndex].Level;
end;

procedure TMainForm.NightBoxClick(Sender: TObject);
begin
//allow editing pokemon's level and number
NightCombo.ItemIndex := WildPkmn.Night[NightBox.ItemIndex].Number -1;
NightLevel.Value := WildPkmn.Night[NightBox.ItemIndex].Level;
end;

procedure TMainForm.MapBoxMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
//when mouse button is up, painting will be disabled
Painting := False;
end;

procedure TMainForm.EventBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
StatusText: String;
R: TRect;
begin
if (X < 0) or (Y < 0) then Exit;
StatusText := 'Y: ' + IntToStr(Y div 32) + ' X: ' + IntToStr(X div 32);
CursorEvent := GetEventData(X div 32,Y div 32);
 case CursorEvent.TypeID of
 EWarp: StatusText := StatusText + ' Warp' + IntToStr(CursorEvent.Number + 1);
 ETrigger: StatusText := StatusText + ' Trigger ' + IntToStr(CursorEvent.Number + 1);
 ESignPost: StatusText := StatusText + ' Signpost ' + IntToStr(CursorEvent.Number + 1);
 EPeople: StatusText := StatusText + ' People ' + IntToStr(CursorEvent.Number + 1);
 else
 StatusText := StatusText + ' No event';
 end;
StatusBar1.Panels[0].Text := StatusText;
//shows event while dragging
if (DraggingEvent) then
 begin
 //check if anything has changed, if not, don't do anything
 if (X div 32 <> DragOldX) or (Y div 32 <> DragOldY) then
  begin
  MapModified := True;
  //repaint old event's background, erase the dragged event from where it were
  R := Rect(DragOldX*32-EventScrollBox.HorzScrollBar.Position,DragOldY*32-EventScrollBox.VertScrollBar.Position,DragOldX*32+32-EventScrollBox.HorzScrollBar.Position,DragOldY*32+32-EventScrollBox.VertScrollBar.Position);
  InvalidateRect(EventScrollBox.Handle,@R,true);
  //change event location
   case SelectedEvent.TypeID of
   EWarp:
    begin
    Warps[SelectedEvent.Number].X := X div 32;
    Warps[SelectedEvent.Number].Y := Y div 32;
    end;
   ETrigger:
    begin
    Triggers[SelectedEvent.Number].X := X div 32;
    Triggers[SelectedEvent.Number].Y := Y div 32;
    end;
   ESignPost:
   begin
    Signposts[SelectedEvent.Number].X := X div 32;
    Signposts[SelectedEvent.Number].Y := Y div 32;
    end;
   EPeople:
    begin
    Peoples[SelectedEvent.Number].X := X div 32;
    Peoples[SelectedEvent.Number].Y := Y div 32;
    end;
   end;
  //draw event to new position
  DrawBox(EventBox.Canvas,X div 32 * 32,Y div 32 * 32,SelectedEvent.TypeID);
  //remember the coordinates so event can be erased again on next move
  DragOldX := X div 32;
  DragOldY := Y div 32;
  end;
 end;
end;

function TMainForm.GetEventData(X,Y: Integer): EventInfo;
var
I: Integer;
begin
//sets eventtype FF in case no event found
Result.TypeID := $FF;
//checks all warps if there's warp in X and Y
for I := 1 to NumOfWarp do
if (Warps[I].X = X) and (Warps[I].Y = Y) then
 begin
 Result.TypeID := EWarp;
 Result.Number := I;
 Exit;
 end;
//checks all triggers if there's trigger in X and Y
for I := 1 to NumOfTrigger do
if (Triggers[I].X = X) and (Triggers[I].Y = Y) then
 begin
 Result.TypeID := ETrigger;
 Result.Number := I;
 Exit;
 end;
//checks all Signposts if there's Signpost in X and Y
for I := 1 to NumOfSignpost do
if (Signposts[I].X = X) and (Signposts[I].Y = Y) then
 begin
 Result.TypeID := ESignPost;
 Result.Number := I;
 Exit;
 end;
//checks all peoples if there's people in X and Y
for I := 1 to NumOfPeople do
if (Peoples[I].X = X) and (Peoples[I].Y = Y) then
 begin
 Result.TypeID := EPeople;
 Result.Number := I;
 Exit;
 end;
end;

procedure TMainForm.EventBoxMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
if Button = mbLeft then
 begin
 SelectedEvent := GetEventData(X div 32, Y div 32);
 if SelectedEvent.TypeID <> $FF then
  begin
  DraggingEvent := True;
  //location where event picture will be erased
  DragOldX := (X div 32);
  DragOldY := (Y div 32);
  //inform OnMouseMove that it should hide other events
  end;
 end;
end;

procedure TMainForm.EventBoxMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
if DraggingEvent then
 begin
 DraggingEvent := False;
 //show the event properties
  case SelectedEvent.TypeID of
  EWarp: WarpForm.Show;
  ETrigger: Beep;
  ESignPost: SignpostForm.Show;
  EPeople: PeopleForm.Show;
  end;
 end;
end;

procedure TMainForm.SaveMapPicture1Click(Sender: TObject);
var
Pic: TPNGObject;
Temp: TBitmap;
begin
with TSaveDialog.Create(nil) do
 begin
 Filter := 'Portable Network Graphics (*.png)|*.png|Bitmap (*.bmp)|*.bmp|All files (*.*)|*.*';
 DefaultExt := '*.png';
 if Execute then
  begin
  Temp := TBitmap.Create;
  Temp.PixelFormat := pf24bit;
  Temp.Width  := MapBox.Width;
  Temp.Height := MapBox.Height;
  DrawMap(Temp.Canvas);
  if FilterIndex <> 2 then
   begin
   Pic := TPNGObject.Create;
   Pic.Assign(Temp);
   Pic.SaveToFile(FileName);
   Pic.Free;
   end
  else
  Temp.SaveToFile(FileName);
  Temp.Free;
  end;
 Free;
 end;
end;

procedure TMainForm.SaveTilesetPicture1Click(Sender: TObject);
var
Pic: TPNGObject;
Temp: TBitmap;
begin
with TSaveDialog.Create(nil) do
 begin
 Filter := 'Portable Network Graphics (*.png)|*.png|Bitmap (*.bmp)|*.bmp|All files (*.*)|*.*';
 DefaultExt := '*.png';
 if Execute then
  begin
  Temp := TBitmap.Create;
  Temp.PixelFormat := pf24bit;
  Temp.Width  := 64;
  Temp.Height := Blocks * 64;
  DrawBlocks(Temp.Canvas);
  if FilterIndex <> 2 then
   begin
   Pic := TPNGObject.Create;
   Pic.Assign(Temp);
   Pic.SaveToFile(FileName);
   Pic.Free;
   end
  else
  Temp.SaveToFile(FileName);
  Temp.Free;
  end;
 Free;
 end;
end;

procedure TMainForm.BuildEvents1Click(Sender: TObject);
begin
with TEventBuilderForm.Create(nil) do
 begin
 ShowModal;
 Free;
 end;
end;

procedure TMainForm.RandomizeButtonClick(Sender: TObject);

 function GetRand(Max,Min: Integer): Integer;
 begin
 Result := Random(Max - Min + 1) + Min;
 end;

var
I,N,L: Integer;
begin
if (MaxPoke.Value < MinPoke.value) or (MaxLev.value < MinLev.value) then
 begin
 MessageDlg('Minmum value must be smaller than maximum value.',mtWarning,[mbOk],0);
 Exit;
 end;
for I := 0 to 6 do
 begin
 MorningBox.ItemIndex := I;
 L := GetRand(MaxLev.value,MinLev.value);
 N := GetRand(MaxPoke.value,MinPoke.value);
 WildPkmn.Morning[I].Level := L;
 WildPkmn.Morning[I].Number := N;
 MorningBox.Items[I] := MorningCombo.Items[N-1] + ' - ' + IntToStr(L);
 end;
for I := 0 to 6 do
 begin
 DayBox.ItemIndex := I;
 L := GetRand(MaxLev.value,MinLev.value);
 N := GetRand(MaxPoke.value,MinPoke.value);
 WildPkmn.Day[I].Level := L;
 WildPkmn.Day[I].Number := N;
 DayBox.Items[I] := MorningCombo.Items[N-1] + ' - ' + IntToStr(L);
 end;
for I := 0 to 6 do
 begin
 NightBox.ItemIndex := I;
 L := GetRand(MaxLev.value,MinLev.value);
 N := GetRand(MaxPoke.value,MinPoke.value);
 WildPkmn.Night[I].Level := L;
 WildPkmn.Night[I].Number := N;
 NightBox.Items[I] := MorningCombo.Items[N-1] + ' - ' + IntToStr(L);
 end;
MapModified := True;
end;

procedure TMainForm.LoadMap1Click(Sender: TObject);
var
Temp: TMemoryStream;
begin
if MapStart < 1 then
 begin
 MessageDlg('Please select a map where you want the file to be loaded.',mtInformation,[mbOK],0);
 Exit;
 end;
if OpenMapDialog.Execute then
 begin
 Temp := TMemoryStream.Create;
 Temp.LoadFromFile(OpenMapDialog.FileName);
 Temp.Read(MapData[0],MapY*MapX);
 Temp.Read(Warps,NumOfWarp * SizeOf(TWarp));
 Temp.Read(Signposts,NumOfSignpost * SizeOf(TSignpost));
 Temp.Read(Peoples,NumOfPeople * SizeOf(TPeople));
 Temp.Read(WildPkmn,SizeOf(TWildPokemonBlock));
 DrawMap(MapBox.Canvas);;
 DrawEvents(EventBox.Canvas);
 UpdatePokemon;
 Temp.Free;
 end;
end;

procedure TMainForm.SaveMap1Click(Sender: TObject);
var
Temp: TMemoryStream;
begin
if MapStart < 1 then
 begin
 MessageDlg('Please load a map first, which you want to write to file.',mtInformation,[mbOK],0);
 Exit;
 end;
SaveMapDialog.FileName := LoadedMap + '.map';
if SaveMapDialog.Execute then
 begin
 Temp := TMemoryStream.Create;
 Temp.Write(MapData[0],MapY*MapX);
 Temp.Write(Warps,NumOfWarp * SizeOf(TWarp));
 Temp.Write(Signposts,NumOfSignpost * SizeOf(TSignpost));
 Temp.Write(Peoples,NumOfPeople * SizeOf(TPeople));
 Temp.Write(WildPkmn,SizeOf(TWildPokemonBlock));
 Temp.SaveToFile(SaveMapDialog.FileName);
 Temp.Free;
 end;
end;

procedure TMainForm.MorningComboChange(Sender: TObject);
begin
//change selcted pokemons number
WildPkmn.Morning[MorningBox.Itemindex].Number := MorningCombo.ItemIndex + 1;
UpdatePokemon;
MapModified := True;
end;

procedure TMainForm.DayComboChange(Sender: TObject);
begin
//change selcted pokemons number
WildPkmn.Day[DayBox.Itemindex].Number := DayCombo.ItemIndex + 1;
UpdatePokemon;
MapModified := True;
end;

procedure TMainForm.NightComboChange(Sender: TObject);
begin
//change selcted pokemons number
WildPkmn.Night[NightBox.Itemindex].Number := NightCombo.ItemIndex + 1;
UpdatePokemon;
MapModified := True;
end;

procedure TMainForm.TryMap1Click(Sender: TObject);
begin
with TTryForm.Create(nil) do
 begin
 Show;
 end;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
with TAboutForm.Create(nil) do
 begin
 ShowModal;
 Free;
 end;
end;

procedure TMainForm.GameTweaks1Click(Sender: TObject);
begin
with TTweaksForm.Create(nil) do
 begin
 ShowModal;
 Free;
 end;
end;

procedure TMainForm.SaveRom(FileName: string);
begin
if MapStart > 0 then
SaveMap;
if (EventsAddr>0) then
SaveEvents;
if PokemonStart > 0 then
SavePokemon;
Rom.SaveToFile(FileName);
RomModified := False;
end;

procedure TMainForm.LoadTileset(TilesetNumber: Byte);
label LoadingDone;
var
X,Y,Block,I,TileX,TileY: Integer;
TileNumber: Byte;
Temp: TBitmap;
TilesetHdr: TTilesetHeader;
begin
//if the tileset needed is already loaded, just exit
if LoadedTileset = TilesetNumber then Exit;
//read the tileset info from ini
TilesetHdr := GetTilesetHeader(TilesetNumber);
TilesetStart := GBPtrToFilePos(TilesetHdr.MapBlockAddr);
if (TilesetStart = 0) or (TilesetStart + $700 > Rom.Size) or (GBPtrToFilePos(TilesetHdr.GraphicsAddr) = 0) or (GBPtrToFilePos(TilesetHdr.GraphicsAddr) + $700 > Rom.Size) then
 begin
 MessageDlg('Tileset information in rom seem to be corrupted. Loading will be cancelled.',mtError,[mbOK],0);
 Abort;
 end;
Temp := TBitmap.Create;
Temp.Width := 8*16;
Temp.Height := 8*6;
Temp.PixelFormat := pf24bit;
//Temp.LoadFromFile(ExtractFilePath(Application.ExeName) + 'Tileset' + IntToStr(TilesetNumber) + '.dib');
ReadTilesetGraphics(GetTilesetHeader(TilesetNumber),Temp);
Tiles.Canvas.StretchDraw(Tiles.Canvas.ClipRect,Temp);
//start loading
StatusBar1.Panels[0].Text := 'Loading Tileset ' + IntToStr(TilesetNumber) + ' please wait...';
//start reading the block data from rom & rendering the tiles
Rom.Position := TilesetStart;
blocks := 255;
For Block := 0 to 255 do
 begin
 for Y := 0 to 3 do
 for X := 0 to 3 do
  begin
  Rom.Read(TileNumber,1);
  if (TileNumber > 96) and (TileNumber and $60 <> $60) and (TileNumber and $F0 <> $F0) then
   begin
   Blocks := Block;
   goto LoadingDone;
   end;
  //create bitmap for block if not already existing
  if BlockPics[Block] = nil then
   begin
   BlockPics[Block] := TBitmap.Create;
   BlockPics[Block].Width := 64;
   BlockPics[Block].Height := 64;
   BlockPics[Block].PixelFormat := pf24bit;
   end;
  //calculate x and y coordinate where to copy tile from, the tileset picture has 16 tiles per line
  TileY := TileNumber div 16;
  TileX := TileNumber mod 16;
  //draw tile to block picture
  BlockPics[Block].Canvas.CopyRect(Rect(X*16,Y*16,X*16+16,Y*16+16),Tiles.Canvas,Rect(TileX*16,TileY*16,TileX*16+16,TileY*16+16));
  end;
 end;
LoadingDone:
BlockPalette.Height := 64 * Blocks;
BlockPalette.Height := 64 * Blocks;
BlockPaletteScrollBox.Show;
SelBlock := 1;
LoadedTileset := TilesetNumber;
//updates blocks because tileset is changed
DrawBlocks(BlockPalette.Canvas);
//enable editing blocks
BlockEditor1.Enabled := True;
StatusBar1.Panels[0].Text := 'Tileset ' + inttostr(TilesetNumber) + ' loaded.';
end;

procedure TMainForm.DrawBlocks(Canvas: TCanvas);
var
I: Integer;
begin
Canvas.Brush.Style := bsClear;
//go through the block pictures and draw then on BlockPalette
for I := 0 to Blocks -1 do
 begin
 Canvas.Draw(0,I*64,BlockPics[I]);
 if Grid1.Checked then
 Canvas.Rectangle(0,I*64,64+64,I*64+64);
 end;
//allow saving tileset picture
SaveTilesetPic1.Enabled := True;
end;

procedure TMainForm.LoadPokemon(MapBank,MapNum: Byte);
var
I: Integer;
begin
//try to find wild pokemon data, there's array of wild pokemon data blocks in rom
PokemonStart := 0;//prepare that we might not find anything
for I := 0 to 63 do
 begin
 Rom.Position := $2AB35 + (I * SizeOf(TWildPokemonBlock));
 Rom.Read(WildPkmn,SizeOf(TWildPokemonBlock));
 if (WildPkmn.MapBank = MapBank) and (WildPkmn.MapNum = MapNum) then
  begin
  PokemonStart := $2AB35 + (I * SizeOf(TWildPokemonBlock));
  Break;
  end;
 end;
//ok, let's try different place
if PokemonStart = 0 then
for I := 0 to 63 do
 begin
 Rom.Position := $2B8DA + (I * SizeOf(TWildPokemonBlock));
 Rom.Read(WildPkmn,SizeOf(TWildPokemonBlock));
 if (WildPkmn.MapBank = MapBank) and (WildPkmn.MapNum = MapNum) then
  begin
  PokemonStart := $2B8DA + (I * SizeOf(TWildPokemonBlock));
  Break;
  end;
 end;
//If there's no wild pokemon data then hide pokemon editors and show label
if PokemonStart = 0 then
 begin
 GroupBox1.hide;
 GroupBox2.hide;
 GroupBox3.hide;
 GroupBox4.hide;
 NoWildPokemonLabel.Show;
 Exit;
 end
else
//otherwise show 'em and hide label
 begin
 GroupBox1.show;
 GroupBox2.show;
 GroupBox3.show;
 GroupBox4.show;
 NoWildPokemonLabel.Hide;
 end;
//Shows pokemon data
UpdatePokemon;
end;

procedure TMainForm.UpdatePokemon;
var
I: Integer;
begin
//show the wild pokemon data in ListBoxes
for I := 0 to 6 do
MorningBox.Items[I] := MorningCombo.Items[WildPkmn.Morning[I].Number -1] + ' - ' + IntToStr(WildPkmn.Morning[I].Level);
MorningTrack.Position := WildPkmn.MorningFreq;
for I := 0 to 6 do
DayBox.Items[I] := DayCombo.Items[WildPkmn.Day[I].Number -1] + ' - ' + IntToStr(WildPkmn.Day[I].Level);
DayTrack.Position := WildPkmn.DayFreq;
for I := 0 to 6 do
NightBox.Items[I] := NightCombo.Items[WildPkmn.Night[I].Number -1] + ' - ' + IntToStr(WildPkmn.Night[I].Level);
NightTrack.Position := WildPkmn.NightFreq;
end;

procedure TMainForm.LoadMap(MapBank,MapNum: Byte);
var
MapHdr1: TMapHeader1;
MapHdr2: TMapHeader2;
begin
//first check if we need to save previously loaded map
if MapModified then
 case MessageDlg('Accept changes?',mtConfirmation,mbYesNoCancel,0) of
 mrYes: SaveMap;
 mrCancel: Abort;
 end;
Rom.Position := GetMapHeader1Addr(Mapbank,MapNum);
Rom.Read(MapHdr1,SizeOf(TMapHeader1));
Rom.Position := GBPtrToFilePos(GBBank(Rom.Position),MapHdr1.Header2Addr);
Rom.Read(MapHdr2,SizeOf(TMapHeader2));
if (MapHdr2.XSize * MapHdr2.YSize = 0) then
 begin
 MessageDlg('There seems be error in map header. Map will not be loaded.',mtWarning,[mbOK],0);
 Abort;
 end;
//ah... now we have ALL info we need in those lovely headers ;)
 case MapHdr1.MapType of
 1: PaletteIndex := 1;
 2: PaletteIndex := 0;
 4: PaletteIndex := 2;
 else
 PaletteIndex := 4;
 end;
Palette1.Items[PaletteIndex].Checked := True;
LoadTileset(MapHdr1.Tileset);
MapStart := GBPtrToFilePos(MapHdr2.MapDataAddr);
MapX     := MapHdr2.XSize;
MapY     := MapHdr2.YSize;
MapBox.Hint   := 'Should work fine... Map Bank ' + IntToStr(MapBank) + ', Map Number ' + IntToStr(MapNum);
EventBox.Hint := 'Should work fine... Map Bank ' + IntToStr(MapBank) + ', Map Number ' + IntToStr(MapNum);
//read map data to array
Rom.Position := MapStart;
if Rom.Size - Rom.Position < MapX *  MapY then
 begin
 MessageDlg('Map is too big to be read from file.',mtWarning,[mbOK],0);
 Abort;
 end;
SetLength(MapData,MapX*MapY);
Rom.Read(MapData[0],MapX * MapY);
//give MapBox right size
MapBox.Height := MapY * 64;
MapBox.Width  := MapX * 64;
//Show map
MapScrollBox.Show;
//load other stuff
LoadEvents(GBPtrToFilePos(MapHdr2.TextAndEventBank,MapHdr2.EventAddress));
LoadPokemon(MapBank,MapNum);
//phew... almost done :)
LoadedMap := AreaNames[MapHdr1.Area] + ' - Map ' + IntToStr(MapNum);
LoadedMapBank := MapBank;
LoadedMapNum  := MapNum;
Caption := 'Gold Map - ' + LoadedMap;
MapModified := False;
SaveMapPic1.Enabled := True;
MapProperties1.Enabled := True;
ReconstructMap1.Enabled := True;
//hide event properties
WarpForm.Hide;
SignpostForm.Hide;
PeopleForm.Hide;
end;

procedure TMainForm.DrawMap(Canvas: TCanvas);
var
X,Y: Integer;
MaxX,MaxY: Integer;
begin
Canvas.Brush.Style := bsClear;
MaxX := Canvas.ClipRect.Right  div 64;
MaxY := Canvas.ClipRect.Bottom div 64;
if MaxX >= MapX then MaxX := MapX-1;
if MaxY >= MapY then MaxY := MapY-1;
for X := Canvas.ClipRect.Left div 64 to MaxX do
for Y := Canvas.ClipRect.Top  div 64 to MaxY do
 begin
 if (MapData[Y * MapX + X] <= Blocks) then
 Canvas.Draw(X * 64,Y * 64,BlockPics[MapData[Y * MapX + X]])
 else
  begin
  Canvas.Brush.Style := bsSolid;
  MapBox.Hint := 'Warning: Map engine detected illegal block(s)!';
  Canvas.Rectangle(X * 64,Y*64,X*64+64,Y*64+64);
  Canvas.Brush.Style := bsClear;
  end;
 //draws grid
 if Grid1.Checked then
 Canvas.Rectangle(X * 64,Y*64,X*64+64,Y*64+64);
 end;
end;

procedure TMainForm.SavePokemon;
begin
if PokemonStart = 0 then
Exit;
//write arrays back to rom
Rom.Position := PokemonStart;
Rom.Write(WildPkmn,SizeOf(TWildPokemonBlock));
end;

procedure TMainForm.SaveMap;
begin
//write map data
Rom.Position := MapStart;
Rom.Write(MapData[0],MapX * MapY);
//save other stuff
SaveEvents;
SavePokemon;
MapModified := False;
RomModified := True;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
if (MapModified) or (RomModified) then
 begin
  case MessageDlg('Save changes to file "' + OpenRomDialog.FileName + '"?',mtConfirmation,mbYesNoCancel,0) of
  mrYes: SaveRom1.Click;
  mrCancel: CanClose := False;
  end;
 end;
end;

procedure TMainForm.MapBoxPaint(Sender: TObject);
begin
DrawMap(MapBox.Canvas);
end;

procedure TMainForm.BlockPalettePaint(Sender: TObject);
begin
DrawBlocks(BlockPalette.Canvas);
end;

procedure TMainForm.EventBoxPaint(Sender: TObject);
begin
DrawEvents(EventBox.Canvas);
end;

procedure TMainForm.MapTreeChange(Sender: TObject; Node: TTreeNode);
var
Tab: Integer;
Bank,Map: Byte;
begin
if Node.Parent <> nil then
 begin
 Bank := (Integer(Node.Data) shr 8) and $FF;
 Map  := (Integer(Node.Data)) and $FF;
 Tab := PageControl1.ActivePageIndex;
 LoadMap(Bank,map);
 PageControl1.ActivePageIndex := Tab;
 end;
end;

procedure TMainForm.BorderComboDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
with TComboBox(Control).Canvas do
 begin
 Draw(Rect.Left,Rect.Top,BlockPics[Index]);
 end;
end;

procedure TMainForm.MapProperties1Click(Sender: TObject);
begin
with TMapPropertiesForm.Create(nil) do
 begin
 ShowModal;
 Free;
 end;
end;

procedure TMainForm.MapTreeDblClick(Sender: TObject);
begin
if (MapTree.Selected <> nil) and (MapTree.Selected.Parent <> nil) then
MapProperties1.Click;
end;

procedure TMainForm.EventBoxDblClick(Sender: TObject);
begin
if CursorEvent.TypeID = EWarp then
 begin
 LoadMap(Warps[CursorEvent.Number].MapBank,Warps[CursorEvent.Number].Map);
 DraggingEvent := False;
 PageControl1.ActivePageIndex := 1;
 end;
end;

procedure TMainForm.SortbyBank1Click(Sender: TObject);
begin
with TMenuItem(Sender) do
 begin
 if not Checked then
  begin
  Checked := True;
  if Rom <> nil then
  ScanMapHeaders;
  end;
 end;
end;

procedure TMainForm.ViewPaletteClick(Sender: TObject);
var
TilesetNum: Byte;
begin
with TMenuItem(Sender) do
 begin
 if not Checked then
  begin
  Checked := True;
  PaletteIndex := Tag;
  if LoadedTileset <> 0 then
   begin
   TilesetNum := LoadedTileset;
   LoadedTileset := 0;//force full re-decode
   LoadTileset(TilesetNum);
   MapBox.Repaint;
   end;
  end;
 end;
end;

procedure TMainForm.AttackTrackChange(Sender: TObject);
begin
WildPkmn.MorningFreq := MorningTrack.Position;
WildPkmn.DayFreq     := DayTrack.Position;
WildPkmn.NightFreq   := NightTrack.Position;
MapModified := True;
end;

procedure TMainForm.ReconstructMap1Click(Sender: TObject);
begin
with TReconstructMapForm.Create(nil) do
 begin
 ShowModal;
 Free;
 end;
end;

end.
