//******************************************************************************
//GoldMap
//by BlueSonic (aka Jigglypuff)
//******************************************************************************
unit ReconstructMap;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Spin, Map;

type
  TReconstructMapForm = class(TForm)
    Label4: TLabel;
    CurrentAddrEdit: TEdit;
    GroupBox1: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    WidthSpin: TSpinEdit;
    HeightSpin: TSpinEdit;
    Button1: TButton;
    Button2: TButton;
    StatusBar1: TStatusBar;
    Label1: TLabel;
    NewAddrEdit: TEdit;
    procedure SizeSpinChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  public
    MapHdr2Addr: Integer;
    MapHdr1: TMapHeader1;
    MapHdr2: TMapHeader2;
    NewMapAddr: Integer;
  end;

var
  ReconstructMapForm: TReconstructMapForm;

implementation

uses Main;

{$R *.dfm}

function FindFreeSpace(Bytes: Integer): Cardinal;
var
Buf: array [0..$4000-1] of Byte;
I: Integer;
begin
Bytes := Bytes + $100;
Result := 0;
for I := 0 to Bytes-1 do
Buf[I] := $00;
for I := $4000 to Rom.Size - Bytes - 1 do
if CompareMem(Pointer(Integer(Rom.Memory) + I),@Buf,Bytes) then
 begin
 Result := I + 1;
 Exit;
 end;
end;

procedure TReconstructMapForm.SizeSpinChange(Sender: TObject);
begin
if WidthSpin.Value * HeightSpin.Value > MapX * MapY then
 begin
 NewMapAddr := FindFreeSpace(WidthSpin.Value * HeightSpin.Value);
 if NewMapAddr <> 0 then
  begin
  StatusBar1.SimpleText := 'Map data will be repointed.';
  NewAddrEdit.Text := '$'+ IntToHex(NewMapAddr,6) + ' (' + IntToHex(GBBank(NewMapAddr),2) + ':' + IntToHex(NewMapAddr mod $4000 + $4000,4) + ')';
  end
 else
 NewAddrEdit.Text := 'Failed finding space.';
 end
else
 begin
 NewMapAddr := MapStart;
 NewAddrEdit.Text := '$'+ IntToHex(MapStart,6) + ' (' + IntToHex(GBBank(MapStart),2) + ':' + IntToHex(MapStart mod $4000 + $4000,4) + ')';
 StatusBar1.SimpleText := 'No need for relocating map data.';
 end;
end;

procedure TReconstructMapForm.FormCreate(Sender: TObject);
begin
MapHdr1 := GetMapHeader1(GetMapHeader1Addr(LoadedMapBank,LoadedMapNum));
MapHdr2Addr := GBPtrToFilePos(MapHdr1.Header2Bank,MapHdr1.Header2Addr);
MapHdr2 := GetMapHeader2(MapHdr1);
CurrentAddrEdit.Text := '$'+ IntToHex(MapStart,6) + ' (' + IntToHex(MapHdr2.MapDataAddr.Bank,2) + ':' + IntToHex(MapHdr2.MapDataAddr.Addr,4) + ')';
WidthSpin.Value  := MapX;
HeightSpin.Value := MapY;
end;

procedure TReconstructMapForm.Button1Click(Sender: TObject);
var
I: Integer;
B: Byte;
Y,X: Integer;
begin
if NewMapAddr = 0 then
 begin
 MessageDlg('Failed to locate enough free space in rom for new map data.',mtWarning,[mbOK],0);
 Exit;
 end;
if WidthSpin.Value * HeightSpin.Value > 1023 then
 begin
 if MessageDlg('Map seem to be too big. Are you sure you want to keep this size? (This is limitation in game - not in GoldMap.)',mtWarning,[mbYes,mbNo],0) = mrNo then
 Exit;
 end;
MainForm.SaveMap;
if (MapX <> WidthSpin.Value) or (MapY <> HeightSpin.Value) then
 begin
 //zero the old map data
 B := 0;
 Rom.Position := MapStart;
 for I := 0 to MapX * MapY - 1 do
 Rom.Write(B,1);
 if WidthSpin.Value * HeightSpin.Value > MapX * MapY then
  begin
  //write new pointer
  MapHdr2.MapDataAddr.Bank := GBBank(NewMapAddr);
  MapHdr2.MapDataAddr.Addr := NewMapAddr mod $4000 + $4000;
  end;
 MapHdr2.YSize := HeightSpin.Value;
 MapHdr2.XSize := WidthSpin.Value;
 Rom.Position := MapHdr2Addr;
 Rom.Write(MapHdr2,SizeOf(MapHdr2));
 //draw the map into new area, and fill the extended area with border bytes
 B := 1;
 Rom.Position := NewMapAddr;
 for Y := 0 to HeightSpin.Value - 1 do
 for X := 0 to WidthSpin.Value  - 1 do
  begin
  if (Y < MapY) and (X < MapX) then
  Rom.Write(MapData[X + Y * MapX],1)
  else
   //extended area -> border if not 00
   begin
   if MapHdr2.BorderBlock <> 0 then
   Rom.Write(MapHdr2.BorderBlock,1)
   else
   Rom.Write(B,1);
   end;
  end;
 end;
MainForm.LoadMap(LoadedMapBank,LoadedMapNum);
MainForm.PageControl1.ActivePageIndex := 0;
Close;
end;

procedure TReconstructMapForm.Button2Click(Sender: TObject);
begin
Close;
end;

end.
