//******************************************************************************
//GoldMap
//by BlueSonic (aka Jigglypuff)
//******************************************************************************
unit Tweaks;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IniFiles, StdCtrls, CheckLst;

type
  TTweaksForm = class(TForm)
    TweakList: TCheckListBox;
    Button1: TButton;
    Button2: TButton;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure StrToByteArray(S: string; var ByteArray: array of Byte; var Size: Byte);
    procedure UpdateTweakList;
    procedure Button1Click(Sender: TObject);
  public
    TweakIni: TIniFile;
    end;

var
  TweaksForm: TTweaksForm;

implementation

uses Main;

{$R *.dfm}

procedure TTweaksForm.Button2Click(Sender: TObject);
begin
Close;
end;

procedure TTweaksForm.FormCreate(Sender: TObject);
begin
TweakIni := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'Tweaks.ini');
TweakIni.ReadSections(TweakList.Items);
UpdateTweakList;
end;

procedure TTweaksForm.FormDestroy(Sender: TObject);
begin
TweakIni.Free;
end;

procedure TTweaksForm.UpdateTweakList;
var
I: Integer;
Offset: Cardinal;
DefaultData: array [0..255] of Byte;
DefaultSize: Byte;
CurrentData: array [0..255] of Byte;
begin
for I := 0 to TweakList.Items.Count - 1 do
 begin
 Offset       := TweakIni.ReadInteger(TweakList.Items[I],'Offset',0);
 StrToByteArray(TweakIni.ReadString(TweakList.Items[I],'DefaultData',''),DefaultData,DefaultSize);
 Rom.Position := Offset;
 Rom.Read(CurrentData,DefaultSize);
 if CompareMem(@DefaultData,@CurrentData,DefaultSize) then
 TweakList.Checked[I] := False
 else
 TweakList.Checked[I] := True;
 end;
end;

procedure TTweaksForm.Button1Click(Sender: TObject);
var
I: Integer;
Offset: Cardinal;
DefaultData: array [0..255] of Byte;
DefaultSize: Byte;
ChangedData: array [0..255] of Byte;
begin
for I := 0 to TweakList.Items.Count - 1 do
 begin
 Offset       := TweakIni.ReadInteger(TweakList.Items[I],'Offset',0);
 StrToByteArray(TweakIni.ReadString(TweakList.Items[I],'DefaultData',''),DefaultData,DefaultSize);
 StrToByteArray(TweakIni.ReadString(TweakList.Items[I],'ChangedData',''),ChangedData,DefaultSize);
 Rom.Position := Offset;
 if TweakList.Checked[I] then
 Rom.Write(ChangedData,DefaultSize)
 else
 Rom.Write(DefaultData,DefaultSize);
 end;
RomModified := True;
Close;
end;

procedure TTweaksForm.StrToByteArray(S: string;
  var ByteArray: array of Byte; var Size: Byte);
var
P: Integer;
begin
Size := 0;
while Length(S) > 0 do
 begin
 P := Pos(',',S);
 if P > 0 then
  begin
  ByteArray[Size] := StrToInt(Copy(S,1,P-1));
  Delete(S,1,P);
  end
 else
  begin
  ByteArray[Size] := StrToInt(S);
  S := '';
  end;
 Inc(Size);
 end;
end;

end.
